summaryrefslogtreecommitdiff
path: root/src/share/common
blob: 54c1b2a14e87908255edca56d8b489d4e72c27ca (plain)
  1. # -*-shell-script-*-
  2. # This should be sourced by bash (though we welcome changes to make it POSIX sh compliant)
  3. # Shared sh functions for the monkeysphere
  4. #
  5. # Written by
  6. # Jameson Rollins <jrollins@finestructure.net>
  7. # Jamie McClelland <jm@mayfirst.org>
  8. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  9. #
  10. # Copyright 2008-2009, released under the GPL, version 3 or later
  11. # all-caps variables are meant to be user supplied (ie. from config
  12. # file) and are considered global
  13. ########################################################################
  14. ### UTILITY FUNCTIONS
  15. # output version info
  16. version() {
  17. cat "${SYSSHAREDIR}/VERSION"
  18. }
  19. # failure function. exits with code 255, unless specified otherwise.
  20. failure() {
  21. [ "$1" ] && echo "$1" >&2
  22. exit ${2:-'255'}
  23. }
  24. # write output to stderr based on specified LOG_LEVEL the first
  25. # parameter is the priority of the output, and everything else is what
  26. # is echoed to stderr. If there is nothing else, then output comes
  27. # from stdin, and is not prefaced by log prefix.
  28. log() {
  29. local priority
  30. local level
  31. local output
  32. local alllevels
  33. local found=
  34. # don't include SILENT in alllevels: it's handled separately
  35. # list in decreasing verbosity (all caps).
  36. # separate with $IFS explicitly, since we do some fancy footwork
  37. # elsewhere.
  38. alllevels="DEBUG${IFS}VERBOSE${IFS}INFO${IFS}ERROR"
  39. # translate lowers to uppers in global log level
  40. LOG_LEVEL=$(echo "$LOG_LEVEL" | tr "[:lower:]" "[:upper:]")
  41. # just go ahead and return if the log level is silent
  42. if [ "$LOG_LEVEL" = 'SILENT' ] ; then
  43. return
  44. fi
  45. for level in $alllevels ; do
  46. if [ "$LOG_LEVEL" = "$level" ] ; then
  47. found=true
  48. fi
  49. done
  50. if [ -z "$found" ] ; then
  51. # default to INFO:
  52. LOG_LEVEL=INFO
  53. fi
  54. # get priority from first parameter, translating all lower to
  55. # uppers
  56. priority=$(echo "$1" | tr "[:lower:]" "[:upper:]")
  57. shift
  58. # scan over available levels
  59. for level in $alllevels ; do
  60. # output if the log level matches, set output to true
  61. # this will output for all subsequent loops as well.
  62. if [ "$LOG_LEVEL" = "$level" ] ; then
  63. output=true
  64. fi
  65. if [ "$priority" = "$level" -a "$output" = 'true' ] ; then
  66. if [ "$1" ] ; then
  67. echo "$@"
  68. else
  69. cat
  70. fi | sed 's/^/'"${LOG_PREFIX}"'/' >&2
  71. fi
  72. done
  73. }
  74. # run command as monkeysphere user
  75. su_monkeysphere_user() {
  76. # our main goal here is to run the given command as the the
  77. # monkeysphere user, but without prompting for any sort of
  78. # authentication. If this is not possible, we should just fail.
  79. # FIXME: our current implementation is overly restrictive, because
  80. # there may be some su PAM configurations that would allow su
  81. # "$MONKEYSPHERE_USER" -c "$@" to Just Work without prompting,
  82. # allowing specific users to invoke commands which make use of
  83. # this user.
  84. # chpst (from runit) would be nice to use, but we don't want to
  85. # introduce an extra dependency just for this. This may be a
  86. # candidate for re-factoring if we switch implementation languages.
  87. case $(id -un) in
  88. # if monkeysphere user, run the command under bash
  89. "$MONKEYSPHERE_USER")
  90. bash -c "$*"
  91. ;;
  92. # if root, su command as monkeysphere user
  93. 'root')
  94. su "$MONKEYSPHERE_USER" -c "$*"
  95. ;;
  96. # otherwise, fail
  97. *)
  98. log error "non-privileged user."
  99. ;;
  100. esac
  101. }
  102. # cut out all comments(#) and blank lines from standard input
  103. meat() {
  104. grep -v -e "^[[:space:]]*#" -e '^$' "$1"
  105. }
  106. # cut a specified line from standard input
  107. cutline() {
  108. head --line="$1" "$2" | tail -1
  109. }
  110. # make a temporary directory
  111. msmktempdir() {
  112. mktemp -d ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  113. }
  114. # make a temporary file
  115. msmktempfile() {
  116. mktemp ${TMPDIR:-/tmp}/monkeysphere.XXXXXXXXXX
  117. }
  118. # this is a wrapper for doing lock functions.
  119. #
  120. # it lets us depend on either lockfile-progs (preferred) or procmail's
  121. # lockfile, and should
  122. lock() {
  123. local use_lockfileprogs=true
  124. local action="$1"
  125. local file="$2"
  126. if ! ( type lockfile-create &>/dev/null ) ; then
  127. if ! ( type lockfile &>/dev/null ); then
  128. failure "Neither lockfile-create nor lockfile are in the path!"
  129. fi
  130. use_lockfileprogs=
  131. fi
  132. case "$action" in
  133. create)
  134. if [ -n "$use_lockfileprogs" ] ; then
  135. lockfile-create "$file" || failure "unable to lock '$file'"
  136. else
  137. lockfile -r 20 "${file}.lock" || failure "unable to lock '$file'"
  138. fi
  139. log debug "lock created on '$file'."
  140. ;;
  141. touch)
  142. if [ -n "$use_lockfileprogs" ] ; then
  143. lockfile-touch --oneshot "$file"
  144. else
  145. : Nothing to do here
  146. fi
  147. log debug "lock touched on '$file'."
  148. ;;
  149. remove)
  150. if [ -n "$use_lockfileprogs" ] ; then
  151. lockfile-remove "$file"
  152. else
  153. rm -f "${file}.lock"
  154. fi
  155. log debug "lock removed on '$file'."
  156. ;;
  157. *)
  158. failure "bad argument for lock subfunction '$action'"
  159. esac
  160. }
  161. # for portability, between gnu date and BSD date.
  162. # arguments should be: number longunits format
  163. # e.g. advance_date 20 seconds +%F
  164. advance_date() {
  165. local gnutry
  166. local number="$1"
  167. local longunits="$2"
  168. local format="$3"
  169. local shortunits
  170. # try things the GNU way first
  171. if date -d "$number $longunits" "$format" &>/dev/null; then
  172. date -d "$number $longunits" "$format"
  173. else
  174. # otherwise, convert to (a limited version of) BSD date syntax:
  175. case "$longunits" in
  176. years)
  177. shortunits=y
  178. ;;
  179. months)
  180. shortunits=m
  181. ;;
  182. weeks)
  183. shortunits=w
  184. ;;
  185. days)
  186. shortunits=d
  187. ;;
  188. hours)
  189. shortunits=H
  190. ;;
  191. minutes)
  192. shortunits=M
  193. ;;
  194. seconds)
  195. shortunits=S
  196. ;;
  197. *)
  198. # this is a longshot, and will likely fail; oh well.
  199. shortunits="$longunits"
  200. esac
  201. date "-v+${number}${shortunits}" "$format"
  202. fi
  203. }
  204. # check that characters are in a string (in an AND fashion).
  205. # used for checking key capability
  206. # check_capability capability a [b...]
  207. check_capability() {
  208. local usage
  209. local capcheck
  210. usage="$1"
  211. shift 1
  212. for capcheck ; do
  213. if echo "$usage" | grep -q -v "$capcheck" ; then
  214. return 1
  215. fi
  216. done
  217. return 0
  218. }
  219. # hash of a file
  220. file_hash() {
  221. if type md5sum &>/dev/null ; then
  222. md5sum "$1"
  223. elif type md5 &>/dev/null ; then
  224. md5 "$1"
  225. else
  226. failure "Neither md5sum nor md5 are in the path!"
  227. fi
  228. }
  229. # convert escaped characters in pipeline from gpg output back into
  230. # original character
  231. # FIXME: undo all escape character translation in with-colons gpg
  232. # output
  233. gpg_unescape() {
  234. sed 's/\\x3a/:/g'
  235. }
  236. # convert nasty chars into gpg-friendly form in pipeline
  237. # FIXME: escape everything, not just colons!
  238. gpg_escape() {
  239. sed 's/:/\\x3a/g'
  240. }
  241. # prompt for GPG-formatted expiration, and emit result on stdout
  242. get_gpg_expiration() {
  243. local keyExpire
  244. keyExpire="$1"
  245. if [ -z "$keyExpire" -a "$PROMPT" != 'false' ]; then
  246. cat >&2 <<EOF
  247. Please specify how long the key should be valid.
  248. 0 = key does not expire
  249. <n> = key expires in n days
  250. <n>w = key expires in n weeks
  251. <n>m = key expires in n months
  252. <n>y = key expires in n years
  253. EOF
  254. while [ -z "$keyExpire" ] ; do
  255. printf "Key is valid for? (0) " >&2
  256. read keyExpire
  257. if ! test_gpg_expire ${keyExpire:=0} ; then
  258. echo "invalid value" >&2
  259. unset keyExpire
  260. fi
  261. done
  262. elif ! test_gpg_expire "$keyExpire" ; then
  263. failure "invalid key expiration value '$keyExpire'."
  264. fi
  265. echo "$keyExpire"
  266. }
  267. passphrase_prompt() {
  268. local prompt="$1"
  269. local fifo="$2"
  270. local PASS
  271. if [ "$DISPLAY" ] && type "${SSH_ASKPASS:-ssh-askpass}" >/dev/null 2>/dev/null; then
  272. printf 'Launching "%s"\n' "${SSH_ASKPASS:-ssh-askpass}" | log info
  273. printf '(with prompt "%s")\n' "$prompt" | log debug
  274. "${SSH_ASKPASS:-ssh-askpass}" "$prompt" > "$fifo"
  275. else
  276. read -s -p "$prompt" PASS
  277. # Uses the builtin echo, so should not put the passphrase into
  278. # the process table. I think. --dkg
  279. echo "$PASS" > "$fifo"
  280. fi
  281. }
  282. # remove all lines with specified string from specified file
  283. remove_line() {
  284. local file
  285. local string
  286. local tempfile
  287. file="$1"
  288. string="$2"
  289. if [ -z "$file" -o -z "$string" ] ; then
  290. return 1
  291. fi
  292. if [ ! -e "$file" ] ; then
  293. return 1
  294. fi
  295. # if the string is in the file...
  296. if grep -q -F "$string" "$file" 2>/dev/null ; then
  297. tempfile=$(mktemp "${file}.XXXXXXX") || \
  298. failure "Unable to make temp file '${file}.XXXXXXX'"
  299. # remove the line with the string, and return 0
  300. grep -v -F "$string" "$file" >"$tempfile"
  301. cat "$tempfile" > "$file"
  302. rm "$tempfile"
  303. return 0
  304. # otherwise return 1
  305. else
  306. return 1
  307. fi
  308. }
  309. # remove all lines with MonkeySphere strings in file
  310. remove_monkeysphere_lines() {
  311. local file
  312. local tempfile
  313. file="$1"
  314. # return error if file does not exist
  315. if [ ! -e "$file" ] ; then
  316. return 1
  317. fi
  318. # just return ok if the file is empty, since there aren't any
  319. # lines to remove
  320. if [ ! -s "$file" ] ; then
  321. return 0
  322. fi
  323. tempfile=$(mktemp "${file}.XXXXXXX") || \
  324. failure "Could not make temporary file '${file}.XXXXXXX'."
  325. egrep -v ' MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2} ' \
  326. "$file" >"$tempfile" || true
  327. cat "$tempfile" > "$file"
  328. rm "$tempfile"
  329. }
  330. # translate ssh-style path variables %h and %u
  331. translate_ssh_variables() {
  332. local uname
  333. local home
  334. uname="$1"
  335. path="$2"
  336. # get the user's home directory
  337. userHome=$(get_homedir "$uname")
  338. # translate '%u' to user name
  339. path=${path/\%u/"$uname"}
  340. # translate '%h' to user home directory
  341. path=${path/\%h/"$userHome"}
  342. echo "$path"
  343. }
  344. # test that a string to conforms to GPG's expiration format
  345. test_gpg_expire() {
  346. echo "$1" | egrep -q "^[0-9]+[mwy]?$"
  347. }
  348. # check that a file is properly owned, and that all it's parent
  349. # directories are not group/other writable
  350. check_key_file_permissions() {
  351. local uname
  352. local path
  353. uname="$1"
  354. path="$2"
  355. if [ "$STRICT_MODES" = 'false' ] ; then
  356. log debug "skipping path permission check for '$path' because STRICT_MODES is false..."
  357. return 0
  358. fi
  359. log debug "checking path permission '$path'..."
  360. "${SYSSHAREDIR}/checkperms" "$uname" "$path"
  361. }
  362. # return a list of all users on the system
  363. list_users() {
  364. if type getent &>/dev/null ; then
  365. # for linux and FreeBSD systems
  366. getent passwd | cut -d: -f1
  367. elif type dscl &>/dev/null ; then
  368. # for Darwin systems
  369. dscl localhost -list /Search/Users
  370. else
  371. failure "Neither getent or dscl is in the path! Could not determine list of users."
  372. fi
  373. }
  374. # take one argument, a service name. in response, print a series of
  375. # lines, each with a unique numeric port number that might be
  376. # associated with that service name. (e.g. in: "https", out: "443")
  377. # if nothing is found, print nothing, and return 0.
  378. #
  379. # return 1 if there was an error in the search somehow
  380. get_port_for_service() {
  381. [[ "$1" =~ ^[a-z0-9]([a-z0-9-]*[a-z0-9])?$ ]] || \
  382. failure $(printf "This is not a valid service name: '%s'" "$1")
  383. if type getent &>/dev/null ; then
  384. # for linux and FreeBSD systems (getent returns 2 if not found, 0 on success, 1 or 3 on various failures)
  385. (getent services "$service" || if [ "$?" -eq 2 ] ; then true ; else false; fi) | awk '{ print $2 }' | cut -f1 -d/ | sort -u
  386. elif [ -r /etc/services ] ; then
  387. # fall back to /etc/services for systems that don't have getent (MacOS?)
  388. # FIXME: doesn't handle aliases like "null" (or "http"?), which don't show up at the beginning of the line.
  389. awk $(printf '/^%s[[:space:]]/{ print $2 }' "$1") /etc/services | cut -f1 -d/ | sort -u
  390. else
  391. return 1
  392. fi
  393. }
  394. # return the path to the home directory of a user
  395. get_homedir() {
  396. local uname=${1:-`whoami`}
  397. eval "echo ~${uname}"
  398. }
  399. # return the primary group of a user
  400. get_primary_group() {
  401. local uname=${1:-`whoami`}
  402. groups "$uname" | sed 's/^..* : //' | awk '{ print $1 }'
  403. }
  404. ### CONVERSION UTILITIES
  405. # output the ssh key for a given key ID
  406. gpg2ssh() {
  407. local keyID
  408. keyID="$1"
  409. gpg --export --no-armor "$keyID" | openpgp2ssh "$keyID" 2>/dev/null
  410. }
  411. # output known_hosts line from ssh key
  412. ssh2known_hosts() {
  413. local host
  414. local port
  415. local key
  416. # FIXME this does not properly deal with IPv6 hosts using the
  417. # standard port (because it's unclear whether their final
  418. # colon-delimited address section is a port number or an address
  419. # string)
  420. host=${1%:*}
  421. port=${1##*:}
  422. key="$2"
  423. # specify the host and port properly for new ssh known_hosts
  424. # format
  425. if [ "$port" != "$host" ] ; then
  426. host="[${host}]:${port}"
  427. fi
  428. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  429. }
  430. # output authorized_keys line from ssh key
  431. ssh2authorized_keys() {
  432. local userID="$1"
  433. local key="$2"
  434. if [[ "$AUTHORIZED_KEYS_OPTIONS" ]]; then
  435. printf "%s %s MonkeySphere%s %s\n" "$AUTHORIZED_KEYS_OPTIONS" "$key" "$DATE" "$userID"
  436. else
  437. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  438. fi
  439. }
  440. # convert key from gpg to ssh known_hosts format
  441. gpg2known_hosts() {
  442. local host
  443. local keyID
  444. local key
  445. host="$1"
  446. keyID="$2"
  447. key=$(gpg2ssh "$keyID")
  448. # NOTE: it seems that ssh-keygen -R removes all comment fields from
  449. # all lines in the known_hosts file. why?
  450. # NOTE: just in case, the COMMENT can be matched with the
  451. # following regexp:
  452. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  453. printf "%s %s MonkeySphere%s\n" "$host" "$key" "$DATE"
  454. }
  455. # convert key from gpg to ssh authorized_keys format
  456. gpg2authorized_keys() {
  457. local userID
  458. local keyID
  459. local key
  460. userID="$1"
  461. keyID="$2"
  462. key=$(gpg2ssh "$keyID")
  463. # NOTE: just in case, the COMMENT can be matched with the
  464. # following regexp:
  465. # '^MonkeySphere[[:digit:]]{4}(-[[:digit:]]{2}){2}T[[:digit:]]{2}(:[[:digit:]]{2}){2}$'
  466. printf "%s MonkeySphere%s %s\n" "$key" "$DATE" "$userID"
  467. }
  468. ### GPG UTILITIES
  469. # script to determine if gpg version is equal to or greater than specified version
  470. is_gpg_version_greater_equal() {
  471. local gpgVersion=$(gpg --version | head -1 | awk '{ print $3 }')
  472. local latest=$(printf '%s\n%s\n' "$1" "$gpgVersion" \
  473. | tr '.' ' ' | sort -g -k1 -k2 -k3 \
  474. | tail -1 | tr ' ' '.')
  475. [[ "$gpgVersion" == "$latest" ]]
  476. }
  477. # retrieve all keys with given user id from keyserver
  478. # FIXME: need to figure out how to retrieve all matching keys
  479. # (not just first N (5 in this case))
  480. gpg_fetch_userid() {
  481. local returnCode=0
  482. local userID
  483. if [ "$CHECK_KEYSERVER" != 'true' ] ; then
  484. return 0
  485. fi
  486. userID="$1"
  487. log verbose " checking keyserver $KEYSERVER... "
  488. echo 1,2,3,4,5 | \
  489. gpg --quiet --batch --with-colons \
  490. --command-fd 0 --keyserver "$KEYSERVER" \
  491. --search ="$userID" &>/dev/null
  492. returnCode="$?"
  493. if [ "$returnCode" != 0 ] ; then
  494. log error "Failure ($returnCode) searching keyserver $KEYSERVER for user id '$userID'"
  495. fi
  496. return "$returnCode"
  497. }
  498. ########################################################################
  499. ### PROCESSING FUNCTIONS
  500. # userid and key policy checking
  501. # the following checks policy on the returned keys
  502. # - checks that full key has appropriate valididy (u|f)
  503. # - checks key has specified capability (REQUIRED_KEY_CAPABILITY)
  504. # - checks that requested user ID has appropriate validity
  505. # (see /usr/share/doc/gnupg/DETAILS.gz)
  506. # output is one line for every found key, in the following format:
  507. #
  508. # flag:sshKey
  509. #
  510. # "flag" is an acceptability flag, 0 = ok, 1 = bad
  511. # "sshKey" is the relevant OpenPGP key, in the form accepted by OpenSSH
  512. #
  513. # all log output must go to stderr, as stdout is used to pass the
  514. # flag:sshKey to the calling function.
  515. process_user_id() {
  516. local returnCode=0
  517. local userID="$1"
  518. local requiredCapability
  519. local requiredPubCapability
  520. local gpgOut
  521. local type
  522. local validity
  523. local keyid
  524. local uidfpr
  525. local usage
  526. local keyOK
  527. local uidOK
  528. local lastKey
  529. local lastKeyOK
  530. local fingerprint
  531. # set the required key capability based on the mode
  532. requiredCapability=${REQUIRED_KEY_CAPABILITY:="a"}
  533. requiredPubCapability=$(echo "$requiredCapability" | tr "[:lower:]" "[:upper:]")
  534. # fetch the user ID if necessary/requested
  535. gpg_fetch_userid "$userID"
  536. # output gpg info for (exact) userid and store
  537. gpgOut=$(gpg --list-key --fixed-list-mode --with-colon \
  538. --with-fingerprint --with-fingerprint \
  539. ="$userID" 2>/dev/null) || returnCode="$?"
  540. # if the gpg query return code is not 0, return 1
  541. if [ "$returnCode" -ne 0 ] ; then
  542. log verbose " no primary keys found."
  543. return 1
  544. fi
  545. # loop over all lines in the gpg output and process.
  546. echo "$gpgOut" | cut -d: -f1,2,5,10,12 | \
  547. while IFS=: read -r type validity keyid uidfpr usage ; do
  548. # process based on record type
  549. case $type in
  550. 'pub') # primary keys
  551. # new key, wipe the slate
  552. keyOK=
  553. uidOK=
  554. lastKey=pub
  555. lastKeyOK=
  556. fingerprint=
  557. log verbose " primary key found: $keyid"
  558. # if overall key is not valid, skip
  559. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  560. log debug " - unacceptable primary key validity ($validity)."
  561. continue
  562. fi
  563. # if overall key is disabled, skip
  564. if check_capability "$usage" 'D' ; then
  565. log debug " - key disabled."
  566. continue
  567. fi
  568. # if overall key capability is not ok, skip
  569. if ! check_capability "$usage" $requiredPubCapability ; then
  570. log debug " - unacceptable primary key capability ($usage)."
  571. continue
  572. fi
  573. # mark overall key as ok
  574. keyOK=true
  575. # mark primary key as ok if capability is ok
  576. if check_capability "$usage" $requiredCapability ; then
  577. lastKeyOK=true
  578. fi
  579. ;;
  580. 'uid') # user ids
  581. if [ "$lastKey" != pub ] ; then
  582. log verbose " ! got a user ID after a sub key?! user IDs should only follow primary keys!"
  583. continue
  584. fi
  585. # if an acceptable user ID was already found, skip
  586. if [ "$uidOK" = 'true' ] ; then
  587. continue
  588. fi
  589. # if the user ID does matches...
  590. if [ "$(echo "$uidfpr" | gpg_unescape)" = "$userID" ] ; then
  591. # and the user ID validity is ok
  592. if [ "$validity" = 'u' -o "$validity" = 'f' ] ; then
  593. # mark user ID acceptable
  594. uidOK=true
  595. else
  596. log debug " - unacceptable user ID validity ($validity)."
  597. fi
  598. else
  599. continue
  600. fi
  601. # output a line for the primary key
  602. # 0 = ok, 1 = bad
  603. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  604. log verbose " * acceptable primary key."
  605. if [ -z "$sshKey" ] ; then
  606. log verbose " ! primary key could not be translated (not RSA?)."
  607. else
  608. echo "0:${sshKey}"
  609. fi
  610. else
  611. log debug " - unacceptable primary key."
  612. if [ -z "$sshKey" ] ; then
  613. log debug " ! primary key could not be translated (not RSA?)."
  614. else
  615. echo "1:${sshKey}"
  616. fi
  617. fi
  618. ;;
  619. 'sub') # sub keys
  620. # unset acceptability of last key
  621. lastKey=sub
  622. lastKeyOK=
  623. fingerprint=
  624. # don't bother with sub keys if the primary key is not valid
  625. if [ "$keyOK" != true ] ; then
  626. continue
  627. fi
  628. # don't bother with sub keys if no user ID is acceptable:
  629. if [ "$uidOK" != true ] ; then
  630. continue
  631. fi
  632. # if sub key validity is not ok, skip
  633. if [ "$validity" != 'u' -a "$validity" != 'f' ] ; then
  634. log debug " - unacceptable sub key validity ($validity)."
  635. continue
  636. fi
  637. # if sub key capability is not ok, skip
  638. if ! check_capability "$usage" $requiredCapability ; then
  639. log debug " - unacceptable sub key capability ($usage)."
  640. continue
  641. fi
  642. # mark sub key as ok
  643. lastKeyOK=true
  644. ;;
  645. 'fpr') # key fingerprint
  646. fingerprint="$uidfpr"
  647. sshKey=$(gpg2ssh "$fingerprint")
  648. # if the last key was the pub key, skip
  649. if [ "$lastKey" = pub ] ; then
  650. continue
  651. fi
  652. # output a line for the sub key
  653. # 0 = ok, 1 = bad
  654. if [ "$keyOK" -a "$uidOK" -a "$lastKeyOK" ] ; then
  655. log verbose " * acceptable sub key."
  656. if [ -z "$sshKey" ] ; then
  657. log error " ! sub key could not be translated (not RSA?)."
  658. else
  659. echo "0:${sshKey}"
  660. fi
  661. else
  662. log debug " - unacceptable sub key."
  663. if [ -z "$sshKey" ] ; then
  664. log debug " ! sub key could not be translated (not RSA?)."
  665. else
  666. echo "1:${sshKey}"
  667. fi
  668. fi
  669. ;;
  670. esac
  671. done | sort -t: -k1 -n -r
  672. # NOTE: this last sort is important so that the "good" keys (key
  673. # flag '0') come last. This is so that they take precedence when
  674. # being processed in the key files over "bad" keys (key flag '1')
  675. }
  676. process_keys_for_file() {
  677. local keyFile="$1"
  678. local userID="$2"
  679. local host
  680. local ok
  681. local sshKey
  682. local noKey=
  683. log verbose "processing: $userID"
  684. log debug "key file: $keyFile"
  685. IFS=$'\n'
  686. for line in $(process_user_id "$userID") ; do
  687. ok=${line%%:*}
  688. sshKey=${line#*:}
  689. if [ -z "$sshKey" ] ; then
  690. continue
  691. fi
  692. # remove the old host key line
  693. if [[ "$keyFile" != '-' ]] ; then
  694. case "$FILE_TYPE" in
  695. ('authorized_keys')
  696. remove_line "$keyFile" "$sshKey" || noKey=true
  697. ;;
  698. ('known_hosts')
  699. host=${userID#ssh://}
  700. remove_line "$keyFile" "${host}.*${sshKey}" || noKey=true
  701. ;;
  702. esac
  703. fi
  704. # if key OK, add new host line
  705. if [ "$ok" -eq '0' ] ; then
  706. case "$FILE_TYPE" in
  707. ('raw')
  708. echo "$sshKey" | log debug
  709. if [[ "$keyFile" == '-' ]] ; then
  710. echo "$sshKey"
  711. else
  712. echo "$sshKey" >>"$keyFile"
  713. fi
  714. ;;
  715. ('authorized_keys')
  716. ssh2authorized_keys "$userID" "$sshKey" | log debug
  717. if [[ "$keyFile" == '-' ]] ; then
  718. ssh2authorized_keys "$userID" "$sshKey"
  719. else
  720. ssh2authorized_keys "$userID" "$sshKey" >> "$keyFile"
  721. fi
  722. ;;
  723. ('known_hosts')
  724. host=${userID#ssh://}
  725. ssh2known_hosts "$host" "$sshKey" | log debug
  726. # hash if specified
  727. if [ "$HASH_KNOWN_HOSTS" = 'true' ] ; then
  728. if (type ssh-keygen >/dev/null) ; then
  729. # FIXME: this is really hackish cause
  730. # ssh-keygen won't hash from stdin to
  731. # stdout
  732. tmpfile=$(mktemp ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
  733. ssh2known_hosts "$host" "$sshKey" \
  734. > "$tmpfile"
  735. ssh-keygen -H -f "$tmpfile" 2>/dev/null
  736. if [[ "$keyFile" == '-' ]] ; then
  737. cat "$tmpfile"
  738. else
  739. cat "$tmpfile" >> "$keyFile"
  740. fi
  741. rm -f "$tmpfile" "${tmpfile}.old"
  742. # FIXME: we could do this without needing
  743. # ssh-keygen. hashed known_hosts looks
  744. # like: |1|X|Y where 1 means SHA1 (nothing
  745. # else is defined in openssh sources), X
  746. # is the salt (same length as the digest
  747. # output), base64-encoded, and Y is the
  748. # digested hostname (also base64-encoded).
  749. # see hostfile.{c,h} in openssh sources.
  750. else
  751. failure "Cannot hash known_hosts as requested"
  752. fi
  753. # log if this is a new key to the known_hosts file
  754. if [ "$noKey" ] ; then
  755. log info "* new key will be added to known_hosts file."
  756. fi
  757. else
  758. if [[ "$keyFile" == '-' ]] ; then
  759. ssh2known_hosts "$host" "$sshKey"
  760. else
  761. ssh2known_hosts "$host" "$sshKey" >>"$keyFile"
  762. fi
  763. fi
  764. ;;
  765. esac
  766. fi
  767. done
  768. }
  769. # process an authorized_user_ids file on stdin for authorized_keys
  770. process_authorized_user_ids() {
  771. local authorizedKeys="$1"
  772. declare -i nline=0
  773. local line
  774. declare -a userIDs
  775. declare -a koptions
  776. # extract user IDs from authorized_user_ids file
  777. IFS=$'\n'
  778. while read line ; do
  779. case "$line" in
  780. ("#"*)
  781. continue
  782. ;;
  783. (" "*|$'\t'*)
  784. if [[ -z ${koptions[${nline}]} ]]; then
  785. koptions[${nline}]=$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')
  786. else
  787. koptions[${nline}]="${koptions[${nline}]},$(echo $line | sed 's/^[ ]*//;s/[ ]$//;')"
  788. fi
  789. ;;
  790. (*)
  791. ((nline++))
  792. userIDs[${nline}]="$line"
  793. unset koptions[${nline}] || true
  794. ;;
  795. esac
  796. done
  797. for i in $(seq 1 $nline); do
  798. AUTHORIZED_KEYS_OPTIONS="${koptions[$i]}" FILE_TYPE='authorized_keys' process_keys_for_file "$authorizedKeys" "${userIDs[$i]}" || returnCode="$?"
  799. done
  800. }
  801. # takes a gpg key or keys on stdin, and outputs a list of
  802. # fingerprints, one per line:
  803. list_primary_fingerprints() {
  804. local fake=$(msmktempdir)
  805. trap "rm -rf $fake" EXIT
  806. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  807. GNUPGHOME="$fake" gpg --with-colons --fingerprint --list-keys | \
  808. awk -F: '/^fpr:/{ print $10 }'
  809. trap - EXIT
  810. rm -rf "$fake"
  811. }
  812. # takes an OpenPGP key or set of keys on stdin, a fingerprint or other
  813. # key identifier as $1, and outputs the gpg-formatted information for
  814. # the requested keys from the material on stdin
  815. get_cert_info() {
  816. local fake=$(msmktempdir)
  817. trap "rm -rf $fake" EXIT
  818. GNUPGHOME="$fake" gpg --no-tty --quiet --import --ignore-time-conflict 2>/dev/null
  819. GNUPGHOME="$fake" gpg --with-colons --fingerprint --fixed-list-mode --list-keys "$1"
  820. trap - EXIT
  821. rm -rf "$fake"
  822. }
  823. check_cruft_file() {
  824. local loc="$1"
  825. local version="$2"
  826. if [ -e "$loc" ] ; then
  827. printf "! The file '%s' is no longer used by\n monkeysphere (as of version %s), and can be removed.\n\n" "$loc" "$version" | log info
  828. fi
  829. }
  830. check_upgrade_dir() {
  831. local loc="$1"
  832. local version="$2"
  833. if [ -d "$loc" ] ; then
  834. printf "The presence of directory '%s' indicates that you have\nnot yet completed a monkeysphere upgrade.\nYou should probably run the following script:\n %s/transitions/%s\n\n" "$loc" "$SYSSHAREDIR" "$version" | log info
  835. fi
  836. }
  837. ## look for cruft from old versions of the monkeysphere, and notice if
  838. ## upgrades have not been run:
  839. report_cruft() {
  840. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-host" 0.23
  841. check_upgrade_dir "${SYSCONFIGDIR}/gnupg-authentication" 0.23
  842. check_cruft_file "${SYSCONFIGDIR}/gnupg-authentication.conf" 0.23
  843. check_cruft_file "${SYSCONFIGDIR}/gnupg-host.conf" 0.23
  844. local found=
  845. for foo in "${SYSDATADIR}/backup-from-"*"-transition" ; do
  846. if [ -d "$foo" ] ; then
  847. printf "! %s\n" "$foo" | log info
  848. found=true
  849. fi
  850. done
  851. if [ "$found" ] ; then
  852. printf "The directories above are backups left over from a monkeysphere transition.\nThey may contain copies of sensitive data (host keys, certifier lists), but\nthey are no longer needed by monkeysphere.\nYou may remove them at any time.\n\n" | log info
  853. fi
  854. }